var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __markAsModule = (target) => __defProp(target, "__esModule", { value: true });
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __reExport = (target, module2, copyDefault, desc) => {
  if (module2 && typeof module2 === "object" || typeof module2 === "function") {
    for (let key of __getOwnPropNames(module2))
      if (!__hasOwnProp.call(target, key) && (copyDefault || key !== "default"))
        __defProp(target, key, { get: () => module2[key], enumerable: !(desc = __getOwnPropDesc(module2, key)) || desc.enumerable });
  }
  return target;
};
var __toCommonJS = /* @__PURE__ */ ((cache) => {
  return (module2, temp) => {
    return cache && cache.get(module2) || (temp = __reExport(__markAsModule({}), module2, 1), cache && cache.set(module2, temp), temp);
  };
})(typeof WeakMap !== "undefined" ? /* @__PURE__ */ new WeakMap() : 0);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  default: () => src_default
});

// src/util/make-rule.ts
function makeRule(rule, meta) {
  return {
    create: rule,
    meta
  };
}

// src/rules/safe-function-exports/errors.ts
var INVALID_FUNCTION_EXPORT = "Cannot have a firebase function that is not exported";

// src/rules/safe-function-exports/index.ts
var safeFunctionExports = makeRule((context) => {
  const hasFirebaseImports = context.getSourceCode().ast.body.some((node) => {
    if (node.type === "ImportDeclaration") {
      const namespaces = node.specifiers.filter((specifier) => specifier.type === "ImportNamespaceSpecifier");
      if (namespaces.length === 0) {
        return false;
      }
      return node.source.type === "Literal" && node.source.value === "firebase-functions" && namespaces.some((namespace) => namespace.local.name === "functions");
    }
    return false;
  });
  if (!hasFirebaseImports) {
    return {};
  }
  return {
    VariableDeclaration(node) {
      const isFirebaseFunction = node.kind === "const" && node.declarations.every((declaration) => {
        return declaration.init && declaration.init.type === "CallExpression" && declaration.init.callee.type === "MemberExpression" && declaration.init.callee.object.type === "MemberExpression" && declaration.init.callee.object.object.type === "Identifier" && declaration.init.callee.object.object.name === "functions" && declaration.init.callee.object.property.type === "Identifier" && declaration.init.callee.object.property.name === "https";
      });
      if (!isFirebaseFunction) {
        return;
      }
      const isExported = node.parent.type === "ExportNamedDeclaration";
      if (!isExported) {
        context.report({
          node,
          message: INVALID_FUNCTION_EXPORT,
          fix(fixer) {
            return [fixer.insertTextBefore(node, "export ")];
          }
        });
      }
    }
  };
}, {
  fixable: "code"
});

// src/index.ts
var src_default = {
  rules: {
    "safe-function-exports": safeFunctionExports
  }
};
module.exports = __toCommonJS(src_exports);
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
